#include<bits/stdc++.h>

using namespace std;

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    long long n, k;
    cin >> n >> k;
    vector<char> a(n);
    for(int i=0;i<n;i++) {
        cin >> a[i];
    }
    vector<long long> pom(k+1);
    pom[(int)a[0] - 97] ++;
    for(int i=0; i<n; i++) {
        pom[(int)a[i] - 97] ++;
        cout << *max(pom.begin(), pom.begin()+k-1) + 1 << " ";
       
    }
    return 0;
}